package command;

import issueData.Comment;
import issueData.IssueRepository;
import org.eclipse.jgit.lib.Config;
import org.eclipse.jgit.lib.Repository;
import org.eclipse.jgit.storage.file.FileRepositoryBuilder;

import java.io.File;
import java.io.IOException;

public class CommandComment implements Command {

    private String id;
    private String comment;

    public CommandComment(String id, String comment) {
        this.id = id;
        this.comment = comment;
    }

    @Override
    public void execute() {
        IssueRepository issueRepository = new IssueRepository();
        String author;

        try {
            Repository repository = new FileRepositoryBuilder()
                    .setGitDir(new File("/home/jack/Documents/testrepo/.issues"))
                    .build();

            Config config = repository.getConfig();

            String name = config.getString("user", null, "name");
            String email = config.getString("user", null, "email");

            if (name == null || email == null) {
                author = "Unknown";
            } else {
                author = "User " + name + " <" + email + ">";
            }

            issueRepository.getIssues().forEach(issue -> {
                if (id.equals(issue.getOriginalHash())) {
                    issue.addComment(new Comment(author, comment));
                    issue.write();
                    System.out.println("Comment added");
                }
            });

        } catch (IOException e) {
            e.printStackTrace();
        }


    }
}
