package command;


import issueData.Issue;
import org.eclipse.jgit.api.Git;
import org.eclipse.jgit.api.errors.GitAPIException;
import org.eclipse.jgit.lib.Config;
import org.eclipse.jgit.lib.Repository;

import java.io.File;
import java.io.IOException;

public class CommandCreate implements Command {

    private String title;
    private String description;
    //    private String path = "/home/jack/Documents/testrepo/";
    private String path = "/home/jack/Documents/testrepo/.issues";

    public CommandCreate(String[] args) {
        this.title = args[0];
        this.description = args[1];
    }


    private void commitAndPush(Issue issue) {
        try (Git git = Git.open(new File(path))) {
            issue.setCreator(getAuthor(git.getRepository()));
            issue.write();
            git.add().addFilepattern(String.valueOf(issue.hashCode())).call();
            git.commit().setMessage("issue created: " + issue.getOriginalHash() + " - title: " + issue.getTitle()).call();

        } catch (GitAPIException | IOException e) {
            e.printStackTrace();
        }
    }

    private String getAuthor(Repository repository) {
        Config config = repository.getConfig();
        String name = config.getString("user", null, "name");
        String email = config.getString("user", null, "email");
        if (name == null || email == null) {
            return "Unknown";
        } else {
            return "User " + name + " Email:" + email;
        }
    }

    public void execute() {
        Issue issue = new Issue(title, description);
        commitAndPush(issue);
        System.out.println("Issue created");
    }
}
